%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Analyzes docking time traces of TIR %
%                                     %
% Xiaowei 10/99                       %
%                                     %
% Rueda 2002-06                       %
% Jan 2005: Added nlfilter            %
% Jul 2006: Added linear filtering    %
%           and 3 state analysis      % 
%                                     %
% Kathy Chaurasiya                    %
% May 2013: Dock window               %
% May 2014: Output files in time      %
%           instead of frames         %
%  Edited by James G for TMR 2015/6   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%********Change Path below accor1ding to where your data is located ********
%path = ('C:\Users\kchauras\Dropbox\Rueda Lab\Data\150306\Slide1Std25\');
path = ('D:\James Gilburt 2015-2017\Intensity distribution measurements\17 10 16 KC SC 1 mM AMPPNP\');
%path = ('/Users/Kathy/Dropbox/Kathy & Roberta/Data/150624/Slide1/');
close all;

skip = 1;
delay = 0;
frametime = 30; % Number of recorded seconds per frame; measured by acquisition prog.

%currentrib = input ('Which file do you want to open? ');
%if isempty(currentrib)
    %currentrib = 1;
%end
% Got bored inputing file id everytime 
% change file input name each time JG 01/16
currentrib = 'KC SC 1 mM AMPPNP 1';
%skip = input ('How many frames did you skip (1)? ');
%if length(skip)==0
%    skip = 1;
%end
%frametime = input ('What is the frametime (30 ms)? ');
%if isempty(frametime)
    %frametime = 30;
%end

%%set up for loading csv files for traces JG 1/16
framerate = 1/frametime; 
filename = strcat(path, currentrib, 'x.txt');
%fid = fopen(filename,'r', 'ieee-le');
filename2 = strcat(path, num2str(currentrib), '.pks');
peaktable = load (filename2);
string1 = strcat(path, 'docktime', num2str(currentrib), '_');
string2 = strcat(path, 'trace_unsmoothed', num2str(currentrib), '_');
string4 = strcat(path, 'trace_smoothed', num2str(currentrib), '_');
string3 = strcat(path, 'hist', num2str(currentrib), '_');
string10 = strcat(path, num2str(currentrib),'pk_int_list', '_');
string11 = strcat(path, num2str(currentrib),'totaltraces', '_');
%Nframes = read(fid, 1, 'int16');
%Nframes = input('How many frames are there in the tiff file?' );
%Nframes = double(Nframes); 
%%% JG changed so number of frames is pre-added below. Manual input can be
%%% included by activating the two lines above
Nframes = double(500);
%disp(strcat('The length of the time traces is:  ', num2str(Nframes)));
axis_x = Nframes;
%Ntraces = fread(fid, 1, 'int16');
Ntraces = length(peaktable); 
Ntraces = double(Ntraces); 
disp(['The number of traces is: ' num2str(Ntraces)])
sizeA = (Ntraces+1)*Nframes ;
%raw = fread(fid,sizeA,'int16');
%raw = read(fid);
%raw = int16(raw);
raw = dlmread(filename);
disp('Done reading data.');
%index = (1:(Ntraces)*Nframes);
time = zeros(1, Nframes);
Data = zeros(Ntraces, Nframes);
Totaltraces = zeros(20000,1); 
TT = double(1);
%donor = zeros(Ntraces/2, Nframes);
%acceptor = zeros(Ntraces/2, Nframes);
%fret = zeros(Ntraces/2, Nframes);
time = (0:(Nframes-1));
%Data(index) = raw(index);
Pkint = zeros(200, 4);
for j = 1:Ntraces ;
    Data(j, :) = raw(:, j);
end
%time1(1,:) = Data(1,:);
time1 = time; 
f_up = 0.25;
f_down = 0.05;
%len = Nframes*frametime;

%for i=1:(Ntraces/2),
    %donor(i,:)=Data(i*2,:);
    %acceptor(i,:)=Data(i*2+1,:);
%end

m1 = input('number of starting trace (1)= ');
if isempty(m1)
    m1 = 1;
end

figure;
%ave_image = imread([path,'rib', num2str(currentrib), '_ave.tif']);
ave_image = imread([path, num2str(currentrib), '_ave.tif']);
subplot (3, 6, [5, 6, 11, 12]); imagesc(ave_image); hold on; title(['Single-Molecule Image '])
h1 = plot(1, 1, 'o', 'color', 'y', 'markersize', 12, 'linewidth', 1.5);
%h2 = plot(1, 1, 'o', 'color', 'r', 'markersize', 12, 'linewidth', 1.5);

%Dock figure instead of setting window position
%set (gcf, 'position', [5 250 1000 445])
set(0,'DefaultFigureWindowStyle','docked')

m = m1;
while (m <= (Ntraces)) && (m > 0)
    time_1 = time1';
    offset = 0;
    %Donorpeak = peaktable((2*m - 1), 2:3);
    %Acceptorpeak = peaktable(2*m, 2:3);        
    peak1 = peaktable(m, 2:3);
    %set(h1,'xdata', Donorpeak(1) + 1, 'ydata', Donorpeak(2) + 1);
    %set(h2,'xdata', Acceptorpeak(1) + 1, 'ydata', Acceptorpeak(2) + 1);
    set(h1, 'xdata', peak1(1)+ 1, 'ydata', peak1(2)+1);
%    for k = 2:len,
%        if (time_1(k-1,1) > time_1(k,1)) & (offset == 0)
%            offset = time_1(k-1,1);
%        end
%        time_1(k,1) = time_1(k,1) + offset;
%    end

    %donor_1 = donor(m,:)';
    %acceptor_1 = acceptor(m,:)'-0.07*donor_1;
    %fret_1 = acceptor_1./(donor_1 + acceptor_1);
    peaktrace1 = Data(m,:);
    % Plot Raw Data
    %subplot (2, 6, 1:3); plot(time_1, donor_1,'b', time_1, acceptor_1,'r'); grid on; zoom on; 
    subplot (3, 6, 1:3); plot(time_1, peaktrace1, 'r'); grid on; zoom on;
    temp=axis; temp(1)=0; temp(2)=axis_x; axis(temp); title(['Molecule ' num2str(m)]);
        
    %subplot(2, 6, 7:9); plot(time_1, fret_1,'m'); grid on; axis([0 axis_x -0.1 1.1]); zoom on; title(['FRET Trace ' num2str(m)])
    
    
    %Histogram
            maxtime = 8000;
            mintime = -200;
            bin = 250; %size of the bin
            
            vxd = mintime:bin:maxtime; %distribution donor            
            %vxa = mintime:bin:maxtime; %distribution acceptor
            %Hd = hist(donor_1(1:Nframes),vxd); %histogram donor
            %Ha = hist(acceptor_1(1:Nframes),vxa); %histogram acceptor
            Pk = hist(peaktrace1(1:Nframes),vxd); %histogram peaktrace
            %maxHd = max(Hd); %maximum count donor
            %maxHa = max(Ha); %maximum count acceptor
            maxPk = max(Pk); %maximum count acceptor
            %NHd = (Hd/maxHd); %donor normalization
            %NHa = (Ha/maxHa); %acceptor normalization      
            NPk = (Pk/maxPk); %peak normalisation
            %Yd = NHd';
            %Ya = NHa';
            Yp = NPk';
            %Y = [Yd -Ya];
            %FRET
            %binfret = 0.01;
            %vxfret = -0.1:binfret:1.1;
            %Hfret = hist(fret_1(1:Nframes),vxfret); 
                      
    %subplot (4, 6, 4); barh(vxd,Yd,'b'); grid on; title(['Histogram Traces ' num2str(m)]); zoom on;
     subplot (4, 6, 13:14); barh(vxd, Pk, 'b'); grid on; title(['Histogram Traces' num2str(m)]); zoom on;
    %subplot (4, 6, 10); barh(vxa,Ya,'r'); grid on; zoom on;
    
    %subplot (2, 6, 10); barh(vxfret,Hfret,'m'); xlim([-0.1 1.1]); grid on; title(['Histogram FRET ' num2str(m)]) 
   
    ans1 = input('press "a" to analyze, "p" for previous,"j" for jump, or "n" for next (n) === ', 's');
    if ans1 == 'p'
        m = m - 1;
    elseif ans1 == 'j'
        ans2 = input ('what number?')
         m = ans2
    elseif ans1 == 'a'
        A = 'q';
        %donor_bg = 0;
        %acceptor_bg = 0;
        tr_bg = 0;
%         t_1 = 0;
%         t_2 = len*skip;
        Mpoints = 3;
        p = 7;
        while (strcmp(A,'y')==0) & (strcmp(A,'d')==0)
        MaxI = input ('Maximum Intensity (8000)? ');
        if length(MaxI)==0
            MaxI = 8000;
        end
        
        %subplot (2, 6, 1:3); plot(time_1,donor_1,'b',time_1,acceptor_1,'r'); grid on; zoom on; 
        %temp=axis; temp(1)=0; temp(2)=axis_x; axis(temp); title(['Molecule ' num2str(m)]);
        subplot (2, 6, 1:3); plot(time_1, peaktrace1, 'b'); grid on; zoom on;
        %subplot (4, 6, 4); barh(vxd,Yd,'b'); grid on; title(['Histogram Traces ' num2str(m)]); zoom on;
        subplot (4, 6, 13:14); barh(vxd, Pk, 'b'); grid on; title(['Histogram Traces' num2str(m)]); zoom on;
    
        %subplot (4, 6, 10); barh(vxa,Ya,'r'); grid on; zoom on;
    
            % Background substraction
            
            %ans2 = input(['donor background (' num2str(donor_bg) ')= ']);
            %if length(ans2)~=0
                %donor_bg = ans2;
            %end
            %ans2 = input(['acceptor background (' num2str(acceptor_bg) ')= ']);
            %if length(ans2)~=0
                %acceptor_bg = ans2;
            %end
            ans2 = input(['Background subtraction: Input background (' num2str(tr_bg) ')= ']);
            if length(ans2)~=0
                tr_bg = ans2;
            end
            %donor_1 = donor(m,:)' - donor_bg;
            %acceptor_1 = acceptor(m,:)' - acceptor_bg-0.1*donor_1;
            %fret_1 = acceptor_1./(acceptor_1 + donor_1);
            peaktrace1 = Data(m,:)' - tr_bg;
            subplot (2, 6, 1:3); plot(time_1, peaktrace1, 'b'); grid on; zoom on;
            

            % Smooth the data
            ans3 = input('Data smoothing: Do you want to average linear [l], non-linear [nl] or no [n] (l)? ', 's');
            if (length(ans3) == 0) | (ans3 == 'l')
                ans4 = input(['M points for linear average (' num2str(Mpoints) ')= ']);
                if length(ans4)~=0
                    Mpoints = ans4;
                end
                %donor_n = donor_1;
                %acceptor_n = acceptor_1;
                pktr_n = peaktrace1; 
                t_1 = Mpoints + 1;
                t_2 = Nframes - (Mpoints);
                for i = t_1:t_2
                    %donor_n(i, 1) = sum(donor_1(((i - Mpoints):(i + Mpoints)), 1))/(2*Mpoints+1);
                    %acceptor_n(i, 1) = sum(acceptor_1(((i - Mpoints):(i + Mpoints)), 1))/(2*Mpoints+1);
                    pktr_n(i, 1) = sum(peaktrace1(((i - Mpoints):(i + Mpoints)),1))/(2*Mpoints+1);
                end
                %fret_n = acceptor_n./(donor_n + acceptor_n);
            elseif ans3 == 'n'
                %donor_n = donor_1;
                %acceptor_n = acceptor_1;
                %fret_n = fret_1;
                pktr_n = peaktrace1;
            elseif ans3 == 'nl'
                ans5 = input(['M points for non-linear weights (' num2str(Mpoints) ')= ']);
                if length(ans5)~=0
                    Mpoints = ans5;
                end
                ans5 = input(['Non-linear exponent p (' num2str(p) ')= ']);
                if ~isempty(ans5)
                    p = ans5;
                end
                %fmdonor = mean(donor_1);
                %fmacceptor = mean(acceptor_1);
                %donor_temp = donor_1/fmdonor;
                %acceptor_temp = acceptor_1/fmacceptor;
                %[donor_n, acceptor_n] = nlfilter([2 4 6 8] , p, donor_temp, acceptor_temp, Mpoints);
                %donor_n = donor_n * fmdonor;
                %acceptor_n = acceptor_n * fmacceptor;
                %fret_n = acceptor_n./(donor_n + acceptor_n);
            end

            % Plot averaged data
            %subplot (2, 6, 1:3); plot(time_1, donor_n,'b',time_1, acceptor_n,'r'); zoom on; grid on; 
            subplot(2, 6, 1:3); plot(time_1, pktr_n, 'b'); zoom on; grid on;
            temp=axis; temp(1)=0; temp(2)=axis_x; axis(temp); title(['Molecule ' num2str(m)]);
            %subplot (2, 6, 7:9); plot(time_1, fret_n,'m'); axis([0 axis_x -0.1 1.1]); grid on; title(['FRET Trace ' num2str(m)])
                    
     
            %Histogram
            binave = 250;
            maxave = MaxI;
            minave = -1000;
            vxdave = minave:binave:maxave; %distribution donor            
            %vxaave = minave:binave:maxave; %distribution acceptor
            %Hdave = hist(donor_n,vxdave); %histogram donor            
            %Haave = hist(acceptor_n,vxaave); %histogram acceptor
            Pkk = hist(pktr_n, vxdave); %averaged/smoothed peak histogram
            %maxHdave = max(Hdave); %maximum count donor
            %maxHaave = max(Haave); %maximum count acceptor
            maxPkk = max(Pkk); %maximum count peak
            %NHdave = (Hdave/maxHdave); %donor normalization
            %NHaave = (Haave/maxHaave); %acceptor normalization
            NHPkk = (Pkk/maxPkk); %Peak normalisation
            %Ydave = NHdave';
            %Yaave = NHaave';
            NHPkkN = NHPkk';
            %Yave = [Ydave Yaave];
            %FRET
            %binfretave = 0.01;
            %vxfretave = -0.1:binfret:1.1;
            %Hfretave = hist(fret_n,vxfretave);
            
            %subplot (4, 6, 4); barh(vxdave,Ydave,'b'); grid on; title(['Histogram Traces ' num2str(m)]);
            subplot (4, 6, 13:14); barh(vxdave, Pkk, 'b'); grid on; title(['Histogram Traces' num2str(m)]); zoom on;
    
            %subplot (4, 6, 10); barh(vxaave,Yaave,'r'); grid on;
            subplot (4, 6, 19:20); barh(vxdave, NHPkkN, 'r'); grid on; title(['Normalised Histogram traces' num2str(m)]); zoom on;
            
            %subplot (2, 6, 10); barh(vxfretave,Hfretave,'m'); ylim([-0.1 1.1]); grid on; title(['Histogram FRET ' num2str(m)]);
        
            % Determine data segment to analyze;
            ans6 = input(['Segment analysis: starting time (' num2str(t_1), ')= ']);
            if length(ans6)~=0
                t_1 = ans6;
            end
            ans6 = input(['ending time (' num2str(t_2) ') = ']);
            if length(ans6)~=0
                t_2 = ans6;                                   
            end
            %Histogram
            maxdel = MaxI;
            mindel = -1000;
            bindel = 250; %size of the bin
            vxddel = mindel:bindel:maxdel; %distribution donor            
            %vxadel = mindel:bindel:maxdel; %distribution acceptor
            %Hddel = hist(donor_n(t_1:t_2),vxddel); %histogram donor            
            %Hadel = hist(acceptor_n(t_1:t_2),vxadel); %histogram acceptor
            HPkl = hist(pktr_n(t_1:t_2), vxddel); %histogram peak section
            %maxHddel = max(Hddel); %maximum count donor
            %maxHadel = max(Hadel); %maximum count acceptor
            maxHPkl = max(HPkl); % max count 
            %NHddel = (Hddel/maxHddel); %donor normalization
            %NHadel = (Hadel/maxHadel); %acceptor normalization
            NHPkl = (HPkl/maxHPkl); % peak normalisation
            %Yddel = NHddel';
            %Yadel = NHadel';
            YHPkl = NHPkl'; 
            %Ydel = [Yddel Yadel];   
            %FRET
            %binfretdel = 0.01;
            %vxfretdel = -0.1:binfretdel:1.1;
            %Hfretdel = hist(fret_n(t_1:t_2),vxfretdel);
            %div = vxfretdel';
            %HistFRET = Hfretdel';
            
            %subplot (2, 6, 1:3); plot(time_1, donor_n,'b',time_1, acceptor_n,'r'); grid on; title(['Molecule ' num2str(m)]); zoom on; 
            %subplot (2, 6, 7:9); plot(time_1, fret_n,'m'); zoom on; axis([0 axis_x -0.1 1.1]); grid on; title(['FRET Trace ' num2str(m)])
            subplot (2, 6, 1:3); plot(time_1(t_1:t_2), pktr_n(t_1:t_2), 'b'); grid on; title(['Molecule ' num2str(m)]); zoom on;
            %subplot (2, 6, 4); barh(vxddel,Yddel,'b'); zoom on; grid on; title(['Histogram Traces ' num2str(m)]);
            subplot (4, 6, 13:14); barh(vxddel, YHPkl, 'b'); zoom on, grid on; title(['time section Histogram Traces' num2str(m)]); zoom on;
           % subplot (2, 6, 10); barh(vxadel,Yadel,'r'); zoom on; grid on;
            
           Xaxis = vxddel';
           Yaxis = NHPkl';
           
           No = m;
           Pkint(No,1) = No;
           plot(Xaxis, Yaxis);
           
           a = input('How many peaks are there?');
           if a == 0;
               display('useless data')
               elseif a == 1;
                   f = fit(Xaxis, Yaxis, 'gauss1');
                   plot(f, Xaxis, Yaxis)
                   Cfv = coeffvalues(f);
                   Pkint(No, 2) =  Cfv(2);
                   elseif a == 2;
                       f = fit(Xaxis, Yaxis, 'gauss2');
                       plot(f, Xaxis, Yaxis)
                       Cfv = coeffvalues(f);
                       Pkint(No, 2) = Cfv(2);
                       Pkint(No, 3) = Cfv(5);
                       elseif a == 3
                           f = fit(Xaxis, Yaxis, 'gauss3');
                           plot(f, Xaxis, Yaxis)
                           Cfv = coeffvalues(f);
                           Pkint(No, 2) = Cfv(2);
                           Pkint(No, 3) = Cfv(5);
                           Pkint(No, 4) = Cfv(8);
                           elseif a > 3 ;
                               display('Too many peaks')
           end
                       
            %subplot (2, 6, 10); barh(vxfretdel, Hfretdel,'m'); ylim([-0.1 1.1]); grid on; title(['Histogram FRET ' num2str(m)]);
       
            %if (t_1 <= Mpoints)
                %t_1 = Mpoints + 1;
            %end
            %if (t_2 >= (Nframes*skip - Mpoints))
                %t_2 = (Nframes*skip - Mpoints - 1);
            %end          
            %if t_1 < delay
                %n_1 = floor(t_1/n)+2;
            %else
                %n_1 = 1 + t_1/skip;
%                n_1 = floor(((t_1-delay)/skip+delay)/n+1);
            %end
            %if t_2 < delay
                %n_2 = floor(t_2/n);
            %else
                %n_2 = t_2/skip;
%                n_2 = floor(((t_2-delay)/skip+delay)/n);
            %end
                        
            % Determine docking and undocking events; Modify f_up and
            % f_down to change criteria.
    		%fret_n_m = zeros(Nframes,1);
            %ans7 = input('Do you want to change jump values, yeah [y] or no-way [n] (n)? ', 's');
            %if ans7 == 'y'
                %ans8 = input (['f_up (' num2str(f_up) ') =']);
                %if length(ans8) ~= 0
                   % f_up = ans8;
                %end
                %ans8 = input (['f_down (' num2str(f_down) ') =']);
                %if length(ans8) ~= 0
                    %f_down = ans8;
                %end
             %end

            %if fret_n(n_1,1) >= f_up
                 %fret_n_m(n_1,1) = 0.5;
            %else
                 %fret_n_m(n_1,1) = 0.0;
            %end
         
            %for i = (n_1+1):n_2
                %if (fret_n_m(i-1,1) == 0.5) & (fret_n(i,1) < f_down)
                    %fret_n_m(i,1) = 0.0;
                %elseif (fret_n_m(i-1,1) == 0.0) & (fret_n(i,1) > f_up)
                    %fret_n_m(i,1) = 0.5;
               % else
                    %fret_n_m(i,1) = fret_n_m(i-1,1);
                %end
            %end

			%subplot (2, 6, 1:3); plot(time_1, donor_n,'b',time_1, acceptor_n,'r'); grid on; title(['Molecule ' num2str(m)]); zoom on; ylim([-50 MaxI]);
            %subplot (2, 6, 7:9); plot(time_1, fret_n, 'm', time_1, fret_n_m, 'k'); ylim([-0.1 1.1]); zoom on; grid on; title(['FRET Trace ' num2str(m)])

            % Calculate the dwell times and save them to file (assumes 3 FRET states A = B = C = A)
            % Convert trace and Hammy output files from frames to seconds
            A = input('satisfied with the results? y = yes, n = no, d = discard === ','s'); 
            if strcmp(A,'y')==1
                k = 0;
                %dwelltimes = zeros(200,6);
                %drop = n_1;
                %flag = 0;
                %for i = n_1:(n_2-1),
                    %if (fret_n_m(i,1) ~= fret_n_m(i+1,1))
                        %if flag == 0
                            %drop = i;
                            %flag = 1;
                        %else
                            %if (fret_n_m(i,1) == 0.0) & (fret_n_m(i+1,1) == 0.5)
                                %k = k + 1;
                                %dwelltimes (k, 1) = time_1(i,1) - time_1(drop,1);
                                %drop = i;
                            %elseif (fret_n_m(i,1) == 0.5) & (fret_n_m(i+1,1) == 0.0)
                                %k = k + 1;
                                %dwelltimes (k, 2) = time_1(i,1) - time_1(drop,1);
                                %drop = i;
                            %end
                        %end
                    %end
                %end
                %dwelltimes = dwelltimes * frametime/1000;
                %output = dwelltimes(1:k, :);
                %fname1 = [string1 num2str(m) '.dat'];
                %save(fname1,'output','-ascii');
                ans5 = input ('to save the unsmoothed trace graph press k === ','s');
                if ans5 == 'k'
                  fname2 = [string2 num2str(m) '.xlsx'];
                  %output = [(time_1(t_1:t_2)*frametime/1000) donor_1(t_1:t_2) acceptor_1(t_1:t_2) donor_n(t_1:t_2) acceptor_n(t_1:t_2)];
                  output = [time_1(t_1:t_2) peaktrace1(t_1:t_2)];
                  xlswrite(fname2,output) ;
                  %output = [(time_1(t_1:t_2)*frametime/1000) donor_n(t_1:t_2) acceptor_n(t_1:t_2)];
                  %save([fname2(1:length(fname2)-4),'Hammy.dat'],'output', '-ascii')
                end
                ans7 = input ('to save smoothed trace graph press k == ', 's');
                if ans7 == 'k'
                    output = [time_1(t_1:t_2) pktr_n(t_1:t_2)];
                    fname4 = [string4 num2str(m) '.xlsx']; 
                    xlswrite(fname4, output);
                    Totaltraces(TT:TT+t_2-t_1, 1) = peaktrace1(t_1:t_2);
                    TT = TT+(t_2-t_1+1); 
                end
                ans6 = input ('to save the histogram press k === ','s');
                 if ans6 == 'k'
                    fname3 = [string3 num2str(m) '.xlsx'];
                    %output = [div HistFRET];
                    output = [vxddel' HPkl'];
                    xlswrite(fname3,output) ;
                 end
                 
            end
        end
        m = m + 1;
    else
        m = m + 1;
    end
    
end
fname10 = [string10 '.xlsx'];
fname11 = [string11 '.xlsx'];
xlswrite(fname10, Pkint);
xlswrite(fname11, Totaltraces); 
    